%define oname CodeNarc
%define with_gmaven 1
%define _with_docs 0

Name:          codenarc
Version:       0.13
Release:       %mkrel 2
Summary:       Groovy library that provides static analysis features for Groovy code
Group:         Development/Java
License:       ASL 2.0
Url:           http://codenarc.sourceforge.net/
Source0:       http://sourceforge.net/projects/codenarc/files/codenarc/CodeNarc%20Version%200.13/CodeNarc-0.13-bin.tar.gz
Source1:       codenarc-0.13-build.xml
Source2:       codenarc-0.13-build.properties
Source3:       codenarc-0.13-depmap
Patch0:        codenarc-0.13-remove_gmaven.patch

BuildRequires: java-devel
BuildRequires: jpackage-utils

BuildRequires: ant
BuildRequires: gmetrics
BuildRequires: groovy
BuildRequires: liblog4j-java
#BuildRequires: asm3
%if %with_gmaven
BuildRequires: fusesource-pom
BuildRequires: gmaven
BuildRequires: gmaven-runtime-1.7
BuildRequires: maven-assembly-plugin
BuildRequires: maven-compiler-plugin
BuildRequires: maven-jar-plugin
BuildRequires: maven-javadoc-plugin
BuildRequires: maven-plugin-cobertura
BuildRequires: maven-project-info-reports-plugin
BuildRequires: maven-surefire-plugin
BuildRequires: maven-dependency-plugin
%endif

Requires:      gmetrics
Requires:      groovy
Requires:      liblog4j-java

Requires:      jpackage-utils
Requires(post): jpackage-utils
Requires(postun): jpackage-utils
Requires:      java
BuildArch:     noarch

%description
CodeNarc is a static analysis tool for Groovy source code,
enabling monitoring and enforcement of many coding standards
and best practices. CodeNarc applies a set of Rules
(predefined and/or custom) that are applied to each Groovy
file, and generates an HTML report of the results, including
a list of rules violated for each source file, and a count
of the number of violations per package and for the whole
project.

%files
%{_javadir}/%{oname}-%{version}.jar
%{_javadir}/%{oname}.jar
%{_javadir}/%{name}.jar
%{_mavenpomdir}/JPP-%{name}.pom
%{_mavendepmapfragdir}/%{name}
%doc CHANGELOG.txt LICENSE.txt NOTICE.txt README.txt

#--------------------------------------------------------------------

%if %_with_docs
%package javadoc
Group:         Development/Java
Summary:       Javadoc for %{name}
Requires:      %{name} = %{version}-%{release} 
Requires:      jpackage-utils

%description javadoc
This package contains javadoc for %{name}.

%files javadoc
%{_javadocdir}/%{name}
%endif

#--------------------------------------------------------------------

%prep
%setup -q -n %{oname}-%{version}

for j in $(find . -name "*.jar" -o -name "*.class"); do
  rm -rf $j
done

rm -rf docs/*
%if !%with_gmaven
%patch0 -p0
%endif
cp -pr %{SOURCE1} build.xml
cp -pr %{SOURCE2} build.propertiess

%build

%if %with_gmaven
mvn-rpmbuild -e -Dmaven.local.depmap.file="%{SOURCE3}" -Dmaven.test.failure.ignore=true install javadoc:aggregate
export CLASSPATH=$(build-classpath groovy-all commons-cli GMetrics)
ant groovydoc
%else
#export CLASSPATH=$(build-classpath groovy commons-cli GMetrics asm3/* )
export CLASSPATH=$(build-classpath groovy-all commons-cli GMetrics)
ant
%endif

%install
[ %{buildroot} != / ] && rm -rf %{buildroot}

install -d -m 755 %{buildroot}T%{_javadir}

%if %with_gmaven
install -Dpm 644 target/%{oname}-%{version}.jar %{buildroot}%{_javadir}/%{oname}-%{version}.jar
%else
install -Dpm 644 target/%{oname}.jar %{buildroot}%{_javadir}/%{oname}-%{version}.jar
%endif

(
  cd %{buildroot}%{_javadir}
  for jar in *-%{version}*; do
    ln -s  ${jar} ${jar/-%{version}/};
  done
  ln -sf %{oname}-%{version}.jar %{name}.jar
)

mkdir -p %{buildroot}%{_mavenpomdir}
install -Dm 644 pom.xml %{buildroot}%{_mavenpomdir}/JPP-%{name}.pom
%add_maven_depmap JPP-%{name}.pom %{name}.jar

%if %_with_docs
mkdir -p %{buildroot}%{_javadocdir}/%{name}
cp -pr target/groovydoc/* %{buildroot}%{_javadocdir}/%{name}
%endif



%changelog

* Mon Jan 09 2012 dmorgan <dmorgan> 0.13-2.mga2
+ Revision: 193946
- Fix build w/o docs

  + gil <gil>
    - build fix added new BR fusesource-pom
    - build fix added new BR maven-dependency-plugin
    - rebuilt with gmaven support
      added  maven pom

* Fri Nov 04 2011 dmorgan <dmorgan> 0.13-1.mga2
+ Revision: 162648
- Clean spec file

  + gil <gil>
    - imported package codenarc

